| contains most the assembler level stuff formerly in trap.c
|

	.text
	.even

| general fault, currently invoked just for buserror 

	.globl _trap
_trap:
	illegal
	btst   #5,sp@
	jeq     Luser_trap
	| we're in supervisor mode then
	moveml  d0-d1/a0-a1,sp@-
	jsr     _kernel_trap_c
	moveml	sp@+,d0-d1/a0-a1
	rte
Luser_trap:
	moveml  d0-d7/a0-a6,sp@-
	movel   usp,a0
	movel   a0,sp@-
	movel   sp,a0
	movel   _active_stacks,a1
	lea     a1@(8192-4),sp
	movel   a0,sp@
	| no return here ever??? 					XXX
	jmp     _user_trap_c


| FIXME: Are we supposed to get syscalls in kernel mode? */

kernel_syscall:
	moveml  d0-d7/a0-a6,sp@-
	movel   usp,a0
	movel   a0,sp@-
	movel   sp,sp@-
	movel   d0,sp@-
	| no return here ever???					XXX
	jmp     _mach_msg_reg_c

	.globl	_syscall
_syscall:
	illegal
	btst    #5,sp@
	jne     kernel_syscall
	moveml  d0-d7/a0-a6,sp@-
	movel   usp,a0
	movel   a0,sp@-
	movel   sp,a0
	movel   _active_stacks,a1
	lea     a1@(8192-4),sp
	movel   a0,sp@
	movel   d0,sp@-
	| no return here ever???					XXX
	jmp     _syscall_c


| FIXME: Are we supposed to get syscalls in kernel mode? */

kernel_mach_msg_reg:
	moveml  d0-d7/a0-a6,sp@-
	movel   usp,a0
	movel   a0,sp@-
	movel   sp,sp@-
	| no return here ever???					XXX
	jmp     _mach_msg_reg_c

	.globl	_mach_msg_reg
_mach_msg_reg:
	illegal
	btst    #5,sp@
	jne     kernel_mach_msg_reg
	moveml  d0-d7/a0-a6,sp@-
	movel   usp,a0
	movel   a0,sp@-
	movel   sp,a0
	movel   _active_stacks,a1
	lea     a1@(8192-4),sp
	movel   a0,sp@
	| no return here ever???					XXX
	jmp     _mach_msg_reg_c


int_table:
	.long	_spurious_int
	.long	_level_1_int_c
	.long	_level_2_int_c
	.long	_level_3_int_c
	.long	_level_4_int_c
	.long	_level_5_int_c
	.long	_level_6_int_c
	.long	_level_7_int

	.globl	_interrupt
_interrupt:
	moveml	d0-d1/a0-a1,sp@-

	moveq	#0,d0
	btst	#5,sp@(4*4)
	sne	d0				| arg!=0 => kernel-int
	movel	d0,sp@-				| pass as argument

	| word@6 looks like this in FORMAT S1 :
	| 0 0 0 1 vector-offset(12 bit)
	| spurious-interrupt has vector-offset 0x60, add the 1 from 0 0 0 1
	lea	pc@(int_table-.+(2-0x1060)),a0
	addw	sp@(4*4+4+6),a0			| index into int_table
	movel	a0@,a0				| fetch C handler
	jsr	a0@				| and call it
	lea	sp@(4),sp			| pop argument

	moveml	sp@+,d0-d1/a0-a1
	rte


	| we don't currently deal with them, so shortcut them here..
_spurious_int:
	| some boards seem to generate spurious NMIs, ignore them
_level_7_int:
	rts
